helper_ver = "smashbroshax-helper beta"
versions_table = {
	{"EUR/JPN 1.0.0", "smashbros_gameotherv100_beaconhax.pcap"},
	{"EUR/JPN 1.0.4", "smashbros_gameotherv104_beaconhax.pcap"},
	{"EUR/JPN 1.1.0", "smashbros_gameotherv110_beaconhax.pcap"},
	{"EUR/JPN 1.1.1", "smashbros_gameotherv111_beaconhax.pcap"},
	{"EUR/JPN 1.1.2", "smashbros_gameotherv112_beaconhax.pcap"},
	
	{"USA 1.0.0", "smashbros_gameusav100_beaconhax.pcap"},
	{"USA 1.0.2", "smashbros_gameusav102_beaconhax.pcap"},
	{"USA 1.0.4", "smashbros_gameusav104_beaconhax.pcap"},
	{"USA 1.0.5", "smashbros_gameusav105_beaconhax.pcap"},
	{"USA 1.1.0", "smashbros_gameusav110_beaconhax.pcap"},
	{"USA 1.1.1", "smashbros_gameusav111_beaconhax.pcap"},
	{"USA 1.1.2", "smashbros_gameusav112_beaconhax.pcap"}
}
versions = ""
for k, v in pairs(versions_table) do
	versions = versions..' a '..k..' "'..v[1]..'"'
end

function question(title, text, ok, cancel)
	return os.execute('zenity --question --title="'..title..'" --text="'..text..'" --ok-label="'..ok..'" --cancel-label="'..cancel..'"')
end
function dialog(title, text)
	return os.execute('zenity --info --title="'..title..'" --text="'..text..'"')
end
function derror(title, text)
	return os.execute('zenity --error --title="'..title..'" --text="'..text..'"')
end

if not question(helper_ver, "This tool will help you easily run yellows8\'s smashbroshax!\n\nThis has only been tested on Debian-based distributions. Ubuntu 15.04 is recommended.\nThis will not work on Fedora/Red Hat-based distributions without manually building aircrack-ng.\n\nYou will need:\n\n - A New Nintendo 3DS\n - A copy of Super Smash Bros. for Nintendo 3DS (demo does not work)\n - A version of SSB4 up to 1.1.2\n   If you have a newer version, you can temporarily delete the update data.\n - A wireless card (built-in and USB should work)\n\nDo you want to continue?", "Continue", "Close") then os.exit() end
interfaces = ""
for v in io.popen("ip -o link"):lines() do
	--table.insert(interfaces, string.sub(v, 4, string.find(v, ":", 4) - 1))
	interfaces = interfaces.." a "..string.sub(v, 4, string.find(v, ":", 4) - 1)
end

interface = io.popen('zenity --list --height="350" --title="'..helper_ver..' - Pick wireless network interface" --text=\'Please pick the wireless interface you want to use.\nIt might look like "wlan0" or "wlp2s0".\nIf you have a USB Wi-Fi adapter, it may have a different name.\n\nNote that ones that look like "wlp2s0" might have problems\nbroadcasting the smashbroshax packet.\' --radiolist --column="" --column="Interface"'..interfaces):read()
print("CHOICE:  '"..interface.."'")

version = io.popen('zenity --list --height="400" --title="'..helper_ver..' - Pick version" --text=\'Please pick the version you have for SSB4.\' --hide-column=2 --radiolist --column="" --column="internal-number" --column="Version"'..versions):read()
print("CHOICE:  '"..version.."'")
print("VERSION: '"..versions_table[tonumber(version)][1].."'")
print("FILE:    '"..versions_table[tonumber(version)][2].."'")

if not question(helper_ver..' - Payload', "Do you have a payload for your system version on your microSD card?\nIt must be named \\\"smashpayload.bin\\\" and placed at the root.\n\nIf you click no, you will be given the choice to open your browser to the payload download.", "Yes", "No") then
	if question(helper_ver..' - Payload', "Would you like to open your browser to download the payload?\n\nSelect your firmware, download the \\\"Otherapp payload\\\",\nrename it to \"smashpayload.bin\", and place it at the root of your SD card.\n\nPlease note that microSD Management does not work on Linux.\nYou must use FTP or insert your microSD card into your computer.", "Open browser", "No") then
		os.execute("xdg-open http://smealum.github.io/3ds/#otherapp")
		dialog(helper_ver..' - Payload', "Download and save the payload to \\\"smashpayload.bin\\\" to the root of your microSD card.\n\nClick OK when ready.")
	else
		derror(helper_ver..' - Payload', "smashbroshax will not work unless you have a \"smashpayload.bin\" file.\n\nThe program will now exit.")
		os.exit()
	end
end

if not question(helper_ver..' - Wireless setup', "If you are connected to the internet using Wi-Fi, you will most likely lose your connection now.\nIf you have another Internet-enabled device (phone, tablet, other computer, etc.),\nyou should use that if you need Internet access.\n\nDo you want to continue?", "Start", "Cancel") then
	os.exit()
end

os.execute("ifconfig "..interface.." down")
os.execute("iwconfig "..interface.." mode monitor")
os.execute("ifconfig "..interface.." up")
os.execute("iwconfig "..interface.." channel 6")

dialog(helper_ver..' - Broadcasting', "A terminal window will now open with aireplay-ng.\nWhen it says \\\"Use this packet ?\\\", type y and press enter.\n\nIf it is broadcasting, it will say \\\"Sent # packets\\\".\nAt this point, on your 3DS, go to SMASH -> Group.\n\nTo stop the broadcasting, click on the terminal window and press Ctrl-C.\n\nIf it does not work, the error should be displayed in the terminal.")

arch = io.popen("getconf LONG_BIT"):read()
os.execute('x-terminal-emulator -e \'bash -c "./aireplay-ng-'..arch..' --interactive -r pcap_out/'..versions_table[tonumber(version)][2]..' -h 59:ee:3f:2a:37:e0 -x 20 '..interface..'; echo -------------------; echo Press any key to continue...; read -sn 1"\'')

os.execute("ifconfig "..interface.." down")
os.execute("iwconfig "..interface.." mode Managed")
os.execute("ifconfig "..interface.." up")

if question(helper_ver..' - Done', "Your wireless card should now be set up to connect to a Wi-Fi access point again.\n\nDo you want to open the tutorial thread on GBAtemp to report your experience or issues?", "Open thread", "Close") then
	os.execute("xdg-open https://gbatemp.net/threads/tutorial-using-smashhax-with-linux.397194/")
end
os.exit()
